aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorWilliam Harrington <kb0iic@berzerkula.org>2021-03-18 11:14:19 -0500
committerWilliam Harrington <kb0iic@berzerkula.org>2021-03-18 11:14:19 -0500
commit3c791ed208ca604cc00f7dd9e7d9cf582f64a639 (patch)
tree9a53bfac78b9e977ae75b04610ec3e1d1f0d9c21
parentc661b9fdbe07971f5902ba763787961bcf24628a (diff)
Add a spinner to display while building and pass the return value of the background process when it ends.
-rw-r--r--spinner.sh25
1 files changed, 25 insertions, 0 deletions
diff --git a/spinner.sh b/spinner.sh
new file mode 100644
index 0000000..4965d8f
--- /dev/null
+++ b/spinner.sh
@@ -0,0 +1,25 @@
+#!/bin/bash
+
+## spinner takes the pid of the process as the first argument and
+# string to display as second argument (default provided) and spins
+# until the process completes.
+spinner() {
+ local PROC="$1"
+ #local str="${2:-'Copyright of KatworX© Tech. Developed by Arjun Singh Kathait and Debugged by the ☆Stack Overflow Community☆'}"
+ local delay="0.1"
+ tput civis # hide cursor
+ printf "${WHT}"
+ while [ -d /proc/$PROC ]; do
+ printf '\033[s\033[u[ / ] %s\033[u' "$str"; sleep "$delay"
+ printf '\033[s\033[u[ — ] %s\033[u' "$str"; sleep "$delay"
+ printf '\033[s\033[u[ \ ] %s\033[u' "$str"; sleep "$delay"
+ printf '\033[s\033[u[ | ] %s\033[u' "$str"; sleep "$delay"
+ done
+ wait $PROC
+ retval=$?
+ printf '\033[s\033[u%*s\033[u\033[0m' $((${#str}+6)) " " # return to normal
+ tput cnorm # restore cursor
+ return 0
+}
+
+export -f spinner \ No newline at end of file